=== debian/changelog ===
likwid (4.2.1+dfsg1-1) unstable; urgency=medium

  * New upstream version 4.2.1+dfsg1
  * remove -Wno-format (closes: #871065)

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 29 Aug 2017 16:04:55 +0200
