=== test/executable_tests/Makefile ===


all: likwid-topology likwid-pin likwid-markerAPI likwid-perfctr likwid-memsweeper likwid-powermeter likwid-bench likwid-genTopoCfg likwid-setFrequencies

likwid-topology:
	./tester.sh likwid-topology
likwid-pin:
	./tester.sh likwid-pin
likwid-perfctr:
	./tester.sh likwid-perfctr
likwid-memsweeper:
	./tester.sh likwid-memsweeper
likwid-powermeter:
	./tester.sh likwid-powermeter
likwid-bench:
	./tester.sh likwid-bench
likwid-mpirun:
	./tester.sh likwid-mpirun
likwid-genTopoCfg:
	./tester.sh likwid-genTopoCfg
likwid-setFrequencies:
	./tester.sh likwid-setFrequencies
likwid-markerAPI:
	make -s -C .. streamGCC
