=== debian/changelog ===
likwid (4.3.1+dfsg1-1) unstable; urgency=medium

  * New upstream version 4.3.1+dfsg1
  * fix build problem with newer libc (closes: #887696)

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 30 Jan 2018 09:34:19 +0100
