=== debian/watch ===
version=3
opts=repacksuffix=+dfsg1,dversionmangle=s/\+dfsg1\d*$// \
  http://ftp.fau.de/pub/likwid/likwid-(\d[\d.]*)\.tar\.gz debian uupdate
