## likwid 4.3.2+dfsg1

=== Makefile ===
--- 
+++ 
@@ -4,8 +4,8 @@
 #
 #      Description:  Central Makefile
 #
-#      Version:   4.3.1
-#      Released:  04.01.2018
+#      Version:   4.3.2
+#      Released:  12.04.2018
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
@@ -163,7 +163,6 @@
 $(PINLIB):
 	@echo "===>  CREATE LIB  $(PINLIB)"
 	$(Q)$(MAKE) -C src/pthread-overload/ $(PINLIB)
-	@ln -sf $(PINLIB) $(PINLIB).$(VERSION).$(RELEASE)
 
 $(GENGROUPLOCK): $(foreach directory,$(shell ls $(GROUP_DIR)), $(wildcard $(GROUP_DIR)/$(directory)/*.txt))
 	@echo "===>  GENERATE GROUP HEADERS"
@@ -179,7 +178,6 @@
 $(TARGET_LUA_LIB):
 	@echo "===>  ENTER  $(LUA_FOLDER)"
 	$(Q)$(MAKE) --no-print-directory -C $(LUA_FOLDER) $(MAKECMDGOALS)
-	@ln -sf $(LUA_FOLDER)/liblikwid-lua.so liblikwid-lua.so.$(VERSION).$(RELEASE)
 else
 $(TARGET_LUA_LIB):
 	@echo "===>  EXTERNAL LUA"
@@ -188,7 +186,6 @@
 $(TARGET_HWLOC_LIB):
 	@echo "===>  ENTER  $(HWLOC_FOLDER)"
 	$(Q)$(MAKE) --no-print-directory -C $(HWLOC_FOLDER) $(MAKECMDGOALS)
-	@ln -sf $(HWLOC_FOLDER)/liblikwid-hwloc.so liblikwid-hwloc.so.$(VERSION).$(RELEASE)
 
 $(BENCH_TARGET):
 	@echo "===>  ENTER  $(BENCH_FOLDER)"
@@ -244,11 +241,13 @@
 	done
 	@rm -f likwid.lua
 	@rm -f $(STATIC_TARGET_LIB)
-	@rm -f $(DYNAMIC_TARGET_LIB)
-	@rm -f $(PINLIB)
+	@rm -f $(DYNAMIC_TARGET_LIB)*
+	@rm -f $(PINLIB)*
 	@rm -f $(FORTRAN_IF_NAME)
 	@rm -f $(FREQ_TARGET) $(DAEMON_TARGET)
 	@rm -rf $(BUILD_DIR)
+	@rm -rf $(TARGET_LUA_LIB).*
+	@rm -rf $(TARGET_HWLOC_LIB).*
 	@rm -f $(GENGROUPLOCK)
 	@rm -rf doc/html
 	@rm -f tags
@@ -335,3 +334,8 @@
 		install -m 755 $$APP  $(BINPREFIX); \
 	done
 	@for APP in $(C_APPS); do \
+		install -m 755 $$APP  $(BINPREFIX); \
+	done
+	@if [ "$(LUA_INTERNAL)" = "true" ]; then \
+		install -m 755 ext/lua/lua $(BINPREFIX)/$(LUA_LIB_NAME); \
+	fi
