=== src/pthread-overload/Makefile ===
--- 
+++ 
@@ -4,8 +4,8 @@
 #
 #      Description:  pthread-overload Makefile
 #
-#      Version:   4.3.1
-#      Released:  04.01.2018
+#      Version:   4.3.2
+#      Released:  12.04.2018
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #               Thomas Roehl (tr), thomas.roehl@googlemail.com
