=== debian/changelog ===
likwid (4.3.2+dfsg1-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field

  [ Christoph Martin ]
  * lua 5.2 bitmask problem fixed
    https://github.com/RRZE-HPC/likwid/issues/191

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 22 Nov 2018 15:56:00 +0100

likwid (4.3.2+dfsg1-1) unstable; urgency=medium

  * fix Files-Excluded glob in copyright file
  * New upstream version 4.3.2+dfsg1

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 17 Sep 2018 08:22:41 +0200

likwid (4.3.1+dfsg1-2) unstable; urgency=medium

  * don't install feedgnuplot, but suggest the Debian version (closes:
    #898682)

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 14 Sep 2018 17:21:33 +0200
