=== examples/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 LIKWID_BINDIR ?= $(PREFIX)/bin
 LIKWID_INCLUDE ?= -I$(PREFIX)/include
 LIKWID_LIBDIR ?= $(PREFIX)/lib
-LIKWID_LIB ?= -llikwid
+LIKWID_LIB ?= -L$(PREFIX)/lib -llikwid
 LIKWID_DEFINES ?= -DLIKWID_PERFMON
 
 all: C-markerAPI C-likwidAPI F-markerAPI Lua-likwidAPI C-markerAPI-run C-likwidAPI-run Lua-likwidAPI-run F-markerAPI-run
@@ -31,7 +31,7 @@
 	$(LIKWID_BINDIR)/likwid-perfctr -C 0 -g INSTR_RETIRED_ANY:FIXC0 -m ./C-markerAPI
 
 C-likwidAPI:
-	$(CC) -fopenmp $(LIKWID_INCLUDE) $(LIKWID_LIBDIR) C-likwidAPI.c -o C-likwidAPI $(LIKWID_LIB) -lm
+	$(CC) -fopenmp $(LIKWID_INCLUDE)  C-likwidAPI.c -o C-likwidAPI $(LIKWID_LIB) -lm
 
 C-likwidAPI-run: C-likwidAPI
 	./C-likwidAPI
