=== debian/changelog ===
likwid (4.3.3+dfsg1-1) unstable; urgency=medium

  * New upstream version 4.3.3+dfsg1

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 21 Dec 2018 13:32:42 +0100
